package com.jiuqi.mde;

import java.util.Hashtable;
import java.util.ArrayList;

public final class MDEDatasetSet
{
    private ArrayList datasets;
    private Hashtable nameSearch;
    
    public MDEDatasetSet() {
        this.datasets = new ArrayList();
        this.nameSearch = new Hashtable();
    }
    
    public int size() {
        return this.datasets.size();
    }
    
    public MDEDataset get(final int index) {
        return this.datasets.get(index);
    }
    
    public MDEDataset find(final String name) {
        return this.nameSearch.get(name);
    }
    
    public void add(final MDEDataset dataset) {
        if (!this.nameSearch.containsKey(dataset.getName())) {
            this.datasets.add(dataset);
            this.nameSearch.put(dataset.getName(), dataset);
        }
    }
    
    public void add(final int index, final MDEDataset dataset) {
        if (!this.nameSearch.containsKey(dataset.getName())) {
            this.datasets.add(index, dataset);
            this.nameSearch.put(dataset.getName(), dataset);
        }
    }
    
    public void add(final MDEDatasetSet datasets) {
        for (int i = 0; i < datasets.size(); ++i) {
            this.add(datasets.get(i));
        }
    }
    
    public void remove(final int index) {
        final MDEDataset dataset = this.datasets.get(index);
        this.nameSearch.remove(dataset.getName());
        this.datasets.remove(index);
    }
    
    public void remove(final MDEDataset dataset) {
        this.datasets.remove(dataset);
        this.nameSearch.remove(dataset.getName());
    }
    
    public int indexOf(final MDEDataset dataset) {
        for (int i = 0; i < this.datasets.size(); ++i) {
            final MDEDataset dim = this.datasets.get(i);
            if (dim == dataset || dim.getName().equals(dataset.getName())) {
                return i;
            }
        }
        return -1;
    }
    
    public Object clone() {
        final MDEDatasetSet result = new MDEDatasetSet();
        result.add(this);
        return result;
    }
    
    public void sortByName() {
        for (int i = 1; i < this.datasets.size(); ++i) {
            final MDEDataset dataset = this.datasets.get(i);
            int start = 0;
            int stop = i - 1;
            int flag = -1;
            while (start <= stop) {
                final int middle = start + stop >> 1;
                flag = dataset.getName().compareTo(this.datasets.get(middle).getName());
                if (flag > 0) {
                    start = middle + 1;
                }
                else {
                    if (flag >= 0) {
                        start = middle;
                        break;
                    }
                    stop = middle - 1;
                }
            }
            if (start < i) {
                for (int k = i; k > start; --k) {
                    this.datasets.set(k, this.datasets.get(k - 1));
                }
                this.datasets.set(start, dataset);
            }
        }
    }
}
